## wcd 5.3.4

=== Makefile ===
#
#	Copyright (C) 2009-2011 Erwin Waterlander
#	Copyright (C) 2009 Jari Aalto
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License as
#	published by the Free Software Foundation; either version 2 of the
#	License, or (at your option) any later version
#
#	This program is distributed in the hope that it will be useful, but
#	WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#	General Public License for more details.
#
#	Visit <http://www.gnu.org/copyleft/gpl.html>


# This makefile is intended only for Unix/Linux.
# See also documentation in directory `doc'.

ifneq (,)
This makefile requires GNU Make.
endif

OBJDIR	= src

all:
	$(MAKE) -C $(OBJDIR)

clean:
	$(MAKE) -C $(OBJDIR) clean

distclean:
	$(MAKE) -C $(OBJDIR) distclean

maintainer-clean:
	$(MAKE) -C $(OBJDIR) maintainer-clean

realclean: maintainer-clean

install:
	$(MAKE) -C $(OBJDIR) install

uninstall:
	$(MAKE) -C $(OBJDIR) uninstall

.PHONY: clean distclean realclean install

# End of file

=== os2/Makefile ===

PREFIX = c:/usr
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LDFLAGS_EXTRA = -Zhigh-mem -Zomf -Zargs-resp

CFLAGS = -O2 -Wall

# PDcurses
#CURSES = pdcurses
# Ncurses
CURSES = ncurses
ENABLE_NLS =
DEFS   =

ifeq ($(CURSES),pdcurses)
LIB_CURSES = pdcurses.a
DEFS   += -DWCD_USECURSES
endif

ifeq ($(CURSES),ncurses)
LIB_CURSES = -lncurses -ltinfo
DEFS   += -DWCD_USECURSES
endif

LIBS_EXTRA = -lcx
ifdef ENABLE_NLS
LIBS_EXTRA += -lintl
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdos2.exe
VERSIONSUFFIX = -os2
ZIPOBJ_EXTRA=bin/wcd.cmd

all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS}
	install -m 755 wcd.cmd $(DESTDIR)${bindir}/wcd.cmd

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}
	-rm -f $(DESTDIR)${bindir}/wcd.cmd


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM}

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== src/Makefile ===
#
#   Copyright information
#
#	Copyright (C) 2009-2016 Erwin Waterlander
#	Copyright (C) 2009 Jari Aalto
#
#   License
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License as
#	published by the Free Software Foundation; either version 2 of the
#	License, or (at your option) any later version
#
#	This program is distributed in the hope that it will be useful, but
#	WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#	General Public License for more details at
#	Visit <http://www.gnu.org/copyleft/gpl.html>.
#
#   Description
#
#	This is a GNU Makefile that uses GNU compilers, linkers and cpp. The
#	platform specific issues are determined by the various OS teets that
#	rely on the uname(1) command and directory locations.
#
#   Developer notes
#
#       In order to clean generated POD files and manuals:
#
#           make maintainer-clean
#
#	Set additional flags for the build with variables CFLAGS_USER,
#	DEFS_USER and LDFLAGS_USER.

ifneq (,)
This makefile requires GNU Make.
endif

include version.mk

.PHONY: status uninstall install install-doc dist dist-zip dist-tgz
.PHONY: man txt html ps pdf mofiles tags merge


.PRECIOUS: %.1 %.pod

CC		?= gcc
STATIC		=
STRIP		= strip

ENABLE_NLS = 1

PACKAGE		= wcd
EXT		= .exe
PROGRAM         = $(PACKAGE)$(EXT)
BIN		= $(PROGRAM)

PREFIX		= /usr
prefix		= $(PREFIX)
exec_prefix	= $(prefix)
bindir		= $(exec_prefix)/bin
datarootdir	= $(prefix)/share
datadir		= $(datarootdir)

docsubdir	= $(PACKAGE)-$(VERSION)
docdir		= $(datarootdir)/doc/$(docsubdir)
localedir	= $(datarootdir)/locale
sysconfdir      = /etc

# 1 = regular, 5 = conf, 6 = games, 8 = daemons
mandir		= $(datarootdir)/man
man1dir		= $(mandir)/man1


# On some systems (e.g. FreeBSD 4.10) GNU install is installed as `ginstall'.
INSTALL		= install
# On some systems (e.g. GNU Win32) GNU mkdir is installed as `gmkdir'.
MKDIR           = mkdir

INSTALL_PROGRAM	= $(INSTALL) -m 755
INSTALL_DATA	= $(INSTALL) -m 644
INSTALL_SUID	= $(INSTALL) -m 4755

INSTALL_OBJS_BIN   = $(BIN)
INSTALL_OBJS_MAN1  = man/man1/wcd.1

HTMLEXT = htm

INSTALL_OBJS_DOC_INSTALL = \
  ../doc/INSTALL.txt \
  ../doc/UNIX.txt \
  ../doc/RPM.txt

INSTALL_OBJS_DOC_COPYING = \
  ../doc/copying.txt

# Documents for end users, not for developers:
INSTALL_OBJS_DOC   = \
  ../doc/faq.txt \
  ../doc/whatsnew.txt \
  ../doc/README.txt \
  ../doc/problems.txt \
  ../doc/todo.txt \
  $(INSTALL_OBJS_DOC_INSTALL) \
  $(INSTALL_OBJS_DOC_COPYING) \
  man/man1/$(PACKAGE).txt \
  man/man1/$(PACKAGE).$(HTMLEXT)

ifdef ENABLE_NLS
POT		= po/$(PACKAGE).pot
POFILES		= $(wildcard po/*.po)
MOFILES		= $(patsubst %.po,%.mo,$(POFILES))
NLSSUFFIX	= -nls
endif
DOCFILES	= man/man1/$(PACKAGE).txt man/man1/$(PACKAGE).$(HTMLEXT)

ifdef ENABLE_NLS
MANPOTFILE      = po-man/wcd-man.pot
MANPOFILES      = $(wildcard po-man/*.po)
PODFILES	= $(patsubst po-man/%.po,man/%/man1/wcd.pod,$(MANPOFILES))
endif
PODFILES_ALL	= man/man1/wcd.pod $(PODFILES)
MANFILES	= $(patsubst %.pod,%.1,$(PODFILES))
TXTFILES	= $(patsubst %.pod,%.txt,$(PODFILES_ALL))
HTMLFILES	= $(patsubst %.pod,%.$(HTMLEXT),$(PODFILES_ALL))
PSFILES 	= $(patsubst %.pod,%.ps,$(PODFILES_ALL))
PDFFILES	= $(patsubst %.pod,%.pdf,$(PODFILES_ALL))

CPP		= cpp
CFLAGS_VERSION	= -DVERSION=\"$(VERSION)\" -DVERSION_DATE=\"$(VERSION_DATE)\"
DEF_UNIX        = -DUNIX
EXTRA_DEFS      =

VERSIONSUFFIX	= -bin

# Large File Support (LFS)
LFS             = 1
# DEBUG=1 adds the -g option to CFLAGS, for adding debug symbols.
DEBUG = 0
# DEBUGMSG=1 adds -DDEBUG=1 to CFLAGS, for extra verbose messages.
DEBUGMSG = 0

wcd_os := $(shell uname)

# Enble Unicode
UCS = 1
ifdef WCD_UTF8
	# WCD_UTF8 was used in older versions.
	UCS=1
endif
ifdef UNINORM
	UCS = 1
endif


ZIPOBJ		= bin/$(BIN) \
		  share/man/man1/$(PACKAGE).1 \
		  share/doc/$(docsubdir)/*.* \
		  $(ZIPOBJ_EXTRA)

INSTALL_TARGETS = install-bin install-man install-doc

ifdef ENABLE_NLS
	INSTALL_TARGETS += install-mo
	ZIPOBJ += share/locale/*/LC_MESSAGES/$(PACKAGE).mo
	ZIPOBJ += share/man/*/man1/$(PACKAGE).1
	ZIPOBJ += share/doc/$(docsubdir)/*/*
endif

ifdef ENABLE_NLS
	NLSDEFS    = -DENABLE_NLS -DLOCALEDIR=\"$(localedir)\" -DPACKAGE=\"$(PACKAGE)\"
endif

# ......................................................... OS flags ...

OS =

ifndef OS
ifeq ($(findstring CYGWIN,$(wcd_os)),CYGWIN)
	OS = cygwin
endif
endif

ifndef OS
ifeq ($(findstring MSYS,$(wcd_os)),MSYS)
	OS = msys
# MSYS 1 does not support locales and no Unicode.
ifeq ($(shell ./chk_loc.sh en_US.utf8),no)
	MSYS_VERSION=1
else
	MSYS_VERSION=2
endif
endif
endif

ifndef OS
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
	OS = mingw
endif
endif

ifndef OS
ifneq ($(DJGPP),)
	OS = msdos
endif
endif

ifndef OS
ifneq (, $(wildcard /opt/csw))
	OS = sun
endif
endif

ifndef OS
	OS=$(shell echo $(wcd_os) | tr [A-Z] [a-z])
endif


ifeq (cygwin,$(OS))
ifdef ENABLE_NLS
	LIBS_EXTRA    = -lintl -liconv -lmpr
else
	LIBS_EXTRA    = -lmpr
endif
	UNINORM = 1  
	LDFLAGS_EXTRA = -Wl,--enable-auto-import
	INSTALL_TARGETS += install-profile
	docsubdir	= $(PACKAGE)
	MACHINE := $(subst -pc-cygwin,,$(shell gcc -dumpmachine))
	VERSIONSUFFIX	= -cygwin-$(MACHINE)
endif

ifeq (os/2,$(OS))
	prefix = c:/usr
	PROGRAM = wcdos2.exe
	DEF_UNIX =
	UCS =
	UNINORM =
	LDFLAGS_EXTRA = -Zhigh-mem -Zomf -Zargs-resp
	ZIPOBJ_EXTRA=bin/wcd.cmd
	VERSIONSUFFIX = -os2
	LIBS_EXTRA = -lcx
ifdef ENABLE_NLS
	LIBS_EXTRA += -lintl
endif
endif

ifeq (mingw,$(OS))
	CC = gcc
	DEF_UNIX =
	LIBS_EXTRA = -lkernel32 -luser32 -lmpr
ifdef ENABLE_NLS
	LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (msdos,$(OS))
	CC = gcc
	DEF_UNIX =
	UCS =
	UNINORM =
endif

ifeq (msys,$(OS))
	CC = gcc
	CFLAGS_OS = -DWCD_MSYS
	PROGRAM = wcdmsys.exe
	LIBS_EXTRA  = -lkernel32 -luser32 -lmpr
	MACHINE := $(subst -pc-msys,,$(shell gcc -dumpmachine))
ifeq ($(MSYS_VERSION),1)
	UCS =
	UNINORM =
	VERSIONSUFFIX = -msys1-$(MACHINE)-$(CURSES)
else
	UCS = 1
	UNINORM = 1
	VERSIONSUFFIX = -msys2-$(MACHINE)
endif
ifdef ENABLE_NLS
	LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (freebsd,$(OS))
	# Running under FreeBSD
ifdef ENABLE_NLS
	CFLAGS_OS     = -I/usr/local/include
	LDFLAGS_EXTRA = -L/usr/local/lib
	LIBS_EXTRA    = -lintl
endif
endif

ifeq (darwin, $(OS))
ifdef ENABLE_NLS
	CFLAGS_OS     = -I/usr/local/include
	LDFLAGS_EXTRA = -L/usr/local/lib
	LIBS_EXTRA    = -lintl
endif
endif


ifeq (sun,$(OS))
	# Running under SunOS/Solaris
	LIBS_EXTRA = -lintl
endif

ifeq (hp-ux,$(OS))
	# Running under HP-UX
	EXTRA_DEFS += -Dhpux -D_HPUX_SOURCE -D_XOPEN_SOURCE_EXTENDED

	# These flags were for native HP compiler
	# CFLAGS_OS = -O -Aa
endif

# .......................................................... unicode ...

ifdef UCS
	CFLAGS_UCS = -std=gnu99
	WDEFS	   = -DWCD_UNICODE
endif
ifdef UNINORM
	CFLAGS_UCS = -std=gnu99
	WDEFS	   = -DWCD_UNICODE -DWCD_UNINORM
	LIB_UNISTRING  = -lunistring
endif

ifdef UCS
UCSSUFFIX = -ucs
EXTRA_OBJ += matchw.o
endif

# ........................................................... curses ...

# possible values: ncurses, curses, pdcurses, pdcursesw or <empty>

ifdef UCS
	CURSES = ncursesw
else
	CURSES = ncurses
endif


# The default console for msys1 is the cmd.exe console.  rxvt and mintty are
# available for msys1, but I guess most people use cmd, console, or conemu for
# msys1.  Therefore we use pdcurses for msys1.  msys2's default console is
# mintty. For msys2 we use ncurses.
ifeq (msys,$(OS))
ifeq ($(MSYS_VERSION),1)
	CURSES = pdcurses
endif
endif

# The native Windows versions use PDCurses, because there are problems
# with the ncurses mingw port.
# All native Windows versions (with and without Unicode support) use wide
# (Unicode) curses functions.
ifeq (mingw,$(OS))
	CURSES = pdcursesw
endif

ifdef CURSES
ifdef UCS
EXTRA_OBJ += wcwidth.o
endif
endif

ifneq (,$(CURSES))
	DEFS_CURSES = -DWCD_USECURSES
	LIB_CURSES  = -l$(CURSES)
ifeq (os/2,$(OS))
	LIB_CURSES  += -ltinfo
endif
endif


INCPREFIX=/usr
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
ifeq ($(shell gcc -dumpmachine),i686-w64-mingw32)
INCPREFIX=/mingw32
CFLAGS_COMPILER = -DWCD_MINGW32_W64=1
else
ifeq ($(shell gcc -dumpmachine),x86_64-w64-mingw32)
INCPREFIX=/mingw64
else
INCPREFIX=/mingw
endif
endif
endif

# Each ncurses variant has its own include directory
# ncurses (normal)/ncursesw (wide char)/ncursest (threads)
ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(wildcard $(INCPREFIX)/include/$(CURSES)/curses.h),)
	INCFLAGS = -I$(INCPREFIX)/include/$(CURSES) -I$(INCPREFIX)/include
endif
ifeq ($(NCURSES_DEBUG), 1)
	LIB_CURSES  = -l$(CURSES)_g
endif
else
	INCFLAGS = -I$(INCPREFIX)/include
endif

ifeq ($(CURSES),ncursesw)
	EXTRA_DEFS += -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED
endif

ifeq ($(CURSES),pdcursesw)
	EXTRA_DEFS += -DPDC_STATIC_BUILD -DPDC_WIDE
endif

# Local installation prefix of ncurses.
#LOCAL_NCURSES	= $(HOME)
#
#ifneq (, $(wildcard $(LOCAL_NCURSES)/include/ncurses.h))
#	NCFLAG = -I$(LOCAL_NCURSES)/include
#	NLFLAG = -L$(LOCAL_NCURSES)/lib
#endif

# ............................................................ flags ...

# Statically linking of a specific library can be done by linking
# to a lib*.a library file instead a lib*.s* library file.
# To link ncurses statically (if your system links by default
# dynamically) comment the LDFLAGS line and add the 'libncurses.a' file
# (often found as /usr/lib/libncurses.a) to the OBJS1 list.

CFLAGS_USER	=
CFLAGS	?= -O2
CFLAGS  += -Wall -Wextra -Wno-unused-parameter -Wconversion $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)

EXTRA_CFLAGS	= -Ic3po \
		  $(CFLAGS_VERSION) \
		  $(CFLAGS_OS) \
		  $(CFLAGS_UCS) \
		  $(CFLAGS_COMPILER) \
		  $(WDEFS) \
		  $(NLSDEFS) \
		  $(NCFLAG) \
		  $(INCFLAGS) \
		  -DDEBUG=$(DEBUGMSG)

ifeq ($(DEBUG), 1)
	EXTRA_CFLAGS += -g
endif

ifdef STATIC
	LDFLAG_STATIC = -static
endif

ifdef LFS
	EXTRA_CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
endif

ifdef ASCII_TREE
	EXTRA_CFLAGS += -DASCII_TREE
endif

LDFLAGS_USER   =
LDFLAGS		= $(RPM_OPT_FLAGS) \
	          $(LDFLAGS_EXTRA) \
		  $(NLFLAG) \
		  $(LDFLAG_STATIC) \
		  $(LDFLAGS_USER)

LIBS = $(LIB_CURSES) \
       $(LIB_UNISTRING) \
       $(LIBS_EXTRA)

DEFS_USER   =
DEFS		= $(DEF_UNIX) $(DEFS_CURSES) $(EXTRA_DEFS) $(DEFS_USER)

# .......................................................... targets ...

OBJS1 = \
	wcd.o \
	match.o \
	stack.o \
	nameset.o \
	intset.o \
	Error.o \
	Text.o \
	WcdStack.o \
	dirnode.o \
	display.o \
	dosdir.o \
	wfixpath.o \
	wcddir.o \
	matchl.o \
	querycp.o \
	$(EXTRA_OBJ)

ifneq (,$(CURSES))
OBJS1 += colors.o \
	graphics.o
endif

all: $(BIN) $(DOCFILES) $(MOFILES) $(INSTALL_OBJS_MAN1) $(MANFILES) $(MANPOTFILE)

status:
	@echo "-- $(PACKAGE) Makefile settings begin --"
	@echo "OS            = $(OS)"
	@echo "prefix        = $(prefix)"
	@echo "EXT           = $(EXT)"
	@echo "UNINORM       = $(UNINORM)"
	@echo "STATIC        = $(STATIC)"
	@echo "UCS           = $(UCS)"
	@echo "ENABLE_NLS    = $(ENABLE_NLS)"
	@echo "CURSES        = $(CURSES)"
	@echo "DEFS          = $(DEFS)"
	@echo "DEFS_CURSES   = $(DEFS_CURSES)"
	@echo "EXTRA_DEFS    = $(EXTRA_DEFS)"
	@echo "LDFLAGS       = $(LDFLAGS)"
	@echo "LDFLAGS_EXTRA = $(LDFLAGS_EXTRA)"
	@echo "LIBS          = $(LIBS)"
	@echo "CFLAGS        = $(CFLAGS)"
	@echo "CFLAGS_OS     = $(CFLAGS_OS)"
	@echo "EXTRA_CFLAGS  = $(EXTRA_CFLAGS)"
	@echo "DEBUG         = $(DEBUG)"
	@echo "DEBUGMSG      = $(DEBUGMSG)"
	@echo "-- $(PACKAGE) Makefile settings end --"

$(BIN): $(OBJS1)
	$(MAKE) status
	$(CC) $(OBJS1) $(LDFLAGS) $(LIBS) -o $@

%.o: %.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(DEFS) -c $< -o $@

wcd.o: wcd.c wcd.h version.mk
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(DEFS) -c $< -o $@

%.o: c3po/%.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(DEFS) -c $< -o $@

%.pdf: %.ps
	ps2pdf $< $@

$(MANPOTFILE) : man/man1/wcd.pod
	$(MAKE) -C man/man1 ../../po-man/$(notdir $@)

#  WARNING: Backward-incompatibility since GNU make 3.82.

=== win32zsh/Makefile ===

PREFIX = c:/usr/local
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LIBS_EXTRA = -lkernel32 -luser32 -lmpr

CFLAGS = -O2 -Wall -Wextra -Wconversion -Wno-unused-parameter
CURSES = pdcursesw
ENABLE_NLS =
DEFS   = -DWCD_WINZSH

ifdef CURSES
LIB_CURSES = -l${CURSES}
DEFS   += -DWCD_USECURSES -DPDC_STATIC_BUILD
DEFS   += -DPDC_WIDE
EXTRA_OBJ += wcwidth.o
endif


ifdef ENABLE_NLS
LIBS_EXTRA += -lintl -liconv
endif

UCS=

ifdef UNINORM
UCS=1
endif

ifdef UCS
EXTRA_OBJ += matchw.o
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdwin32zsh.exe
VERSIONSUFFIX = -win32zsh
ZIPOBJ_EXTRA =
ifdef ENABLE_NLS
# Using MinGW gettext,iconv
ZIPOBJ_EXTRA += bin/libintl-8.dll bin/libiconv-2.dll
# libgcc_s_dw2-1 and libwinpthread-1 are needed when built with MSYS2 
ZIPOBJ_EXTRA += bin/libgcc_s_dw2-1.dll bin/libwinpthread-1.dll
endif

ifdef UNINORM
ifndef ENABLE_NLS
ZIPOBJ_EXTRA += bin/libgcc_s_dw2-1.dll bin/libwinpthread-1.dll
# libunistring needs libiconv
ZIPOBJ_EXTRA += bin/libiconv-2.dll
endif
ZIPOBJ_EXTRA += bin/libunistring-2.dll
endif

ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(findstring libwinpthread,$(ZIPOBJ_EXTRA)),libwinpthread)
ZIPOBJ_EXTRA += bin/libwinpthread-1.dll
endif
endif


all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} EXTRA_OBJ="${EXTRA_OBJ}" ENABLE_NLS=${ENABLE_NLS} UCS=${UCS}

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} EXTRA_OBJ="${EXTRA_OBJ}" INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS} UCS=${UCS}

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS} UCS=${UCS}


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS} UCS=${UCS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM}

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== win64/Makefile ===

PREFIX = c:/usr/local64
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LIBS_EXTRA = -lkernel32 -luser32 -lmpr

#CC = x86_64-w64-mingw32-gcc
#STRIP = x86_64-w64-mingw32-strip
CC = gcc
STRIP = strip
CFLAGS = -O2 -Wall -Wextra -Wconversion -Wno-unused-parameter
CURSES = pdcursesw
ENABLE_NLS =
DEFS   =

ifdef CURSES
LIB_CURSES = -l${CURSES}
DEFS   += -DWCD_USECURSES -DPDC_STATIC_BUILD
DEFS   += -DPDC_WIDE
EXTRA_OBJ += wcwidth.o
endif


ifdef ENABLE_NLS
LIBS_EXTRA += -lintl -liconv
endif

UCS=1

ifdef UNINORM
UCS=1
endif

ifdef UCS
EXTRA_OBJ += matchw.o
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdwin64.exe
VERSIONSUFFIX = -win64
ZIPOBJ_EXTRA = bin/wcd.bat
ifdef ENABLE_NLS
# Using MinGW gettext,iconv
ZIPOBJ_EXTRA += bin/libintl-8.dll bin/libiconv-2.dll
endif

ifdef UNINORM
ifndef ENABLE_NLS
# libunistring needs libiconv
ZIPOBJ_EXTRA += bin/libiconv-2.dll
endif
ZIPOBJ_EXTRA += bin/libunistring-2.dll
endif

ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(findstring libwinpthread,$(ZIPOBJ_EXTRA)),libwinpthread)
ZIPOBJ_EXTRA += bin/libwinpthread-1.dll
endif
endif


all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} EXTRA_OBJ="${EXTRA_OBJ}" ENABLE_NLS=${ENABLE_NLS} CC=$(CC)

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} EXTRA_OBJ="${EXTRA_OBJ}" INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS} CC=$(CC)
	install -m 755 wcd.bat $(DESTDIR)${bindir}/wcd.bat

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}
	-rm -f $(DESTDIR)${bindir}/wcd.bat


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM} STRIP=$(STRIP)

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== src/man/man1/Makefile ===
# pod2man.mk -- Makefile portion to convert *.pod files to manual pages
#
#   Copyright information
#
#	Copyright (C) 2008-2009 Jari Aalto
#	Copyright (C) 2010-2016 Erwin Waterlander
#
#   License
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License as
#	published by the Free Software Foundation; either version 2 of the
#	License, or (at your option) any later version
#
#	This program is distributed in the hope that it will be useful, but
#	WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#	General Public License for more details at
#	Visit <http://www.gnu.org/copyleft/gpl.html>.
#
#   Description
#
# 	Convert *.pod files to manual pages.

ifneq (,)
    This makefile requires GNU Make.
endif

.PRECIOUS: %.pod

# This variable *must* be set when calling
PACKAGE		?= wcd

# Optional variables to set
MANSECT		?= 1
PODCENTER	?= $$(date "+%Y-%m-%d")

# Directories
MANSRC		=
MANDEST		= $(MANSRC)

MANPOD		= $(MANSRC)$(PACKAGE).pod
MANPAGE		= $(MANDEST)$(PACKAGE).$(MANSECT)

POD2MAN		= pod2man
POD2MAN_FLAGS	=

POFILES = $(wildcard ../*/man1/wcd.po)
PODFILES = $(patsubst %.po,%.pod,$(POFILES))
MAN_OBJECTS = wcd.1 $(patsubst %.pod,%.1,$(PODFILES))

MKDIR = mkdir

all: $(MAN_OBJECTS) ../../po-man/wcd-man.pot


../../po-man/wcd-man.pot : wcd.pod
	po4a-updatepo -f pod -m $< -p $@ --msgmerge-opt --no-wrap

%.po : wcd.pod
	po4a-updatepo -f pod -m $< -p $@ --msgmerge-opt "--backup=numbered --no-wrap"
	# change timestamp in case .po file was not updated.
	touch $@

# Create pod files from po.
# Fix problem that =encoding is before =pod command.
../%/man1/wcd.pod : ../../po-man/%.po
	$(MKDIR) -p $(dir $@)
	po4a-translate -f pod -m wcd.pod -p $< > $@ -k 30
	perl -ni.bak -e 'print unless /=encoding UTF-8/' $@
	perl -pli.bak -e 's/=pod/=pod\n\n=encoding UTF-8/' $@

# An empty recipe for wcd.pod to break circular dependency.
wcd.pod : ;

%.1 : %.pod
	# make target - create manual page from a *.pod page
	podchecker $<
	$(POD2MAN) $(POD2MAN_FLAGS) \
		--utf8 \
		--center="$(PODCENTER)" \
		--name="$(PACKAGE)" \
		--section="$(MANSECT)" \
		$< \
	| perl -p -e 's/[Pp]erl v[0-9.]+/$(PACKAGE)/;' \
	  > $@ && \
	rm -f pod*.tmp



clean:
	rm -f $(MAN_OBJECTS)
	rm -f wcd-man.pot
	rm -f $(PODFILES)

# End of of Makefile part

=== debian/changelog ===
wcd (5.3.4-1build2) bionic; urgency=medium

  * Rebuild against new libunistring 0.9.9.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 04 Mar 2018 09:26:28 +0100

wcd (5.3.4-1build1) bionic; urgency=medium

  * Rebuild against new libunistring2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 13 Feb 2018 16:31:07 +0100

wcd (5.3.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - (Build-Depends): use debhelper 10.
  * debian/copyright
    - Update years.
  * debian/patches
    - (10): Update. Use version.mk from original sources for date.

 -- Jari Aalto <jari.aalto@cante.net>  Sun, 08 Jan 2017 13:19:45 +0200

wcd (5.3.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - (Homepage): Update.
    - (Standards-Version): Update to 3.9.8.
    - (Vcs-*): Update to anonscm.debian.org.
  * debian/copyright
    - Update URLs.
  * debian/patches
    - (10): New. Make build reproducible (Closes: 796375).
      Patch thanks to Eduard Sanou <dhole@openmailbox.org>.
  * debian/source/options
    - New file.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 20 Oct 2016 17:47:37 +0300

=== debian/control ===
Source: wcd
Section: utils
Priority: optional
Maintainer: Jari Aalto <jari.aalto@cante.net>
Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 10), libncursesw5-dev, libunistring-dev, ghostscript
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/wcd.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/wcd.git
Homepage: http://waterlan.home.xs4all.nl

Package: wcd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: saves time typing when you want to change directories
 Wcd (Wherever Change Directory) is a program to quickly change directories.
 It saves time typing at the keyboard. One needs to type only a part of a
 directory name and wcd will jump to it. By default, wcd searches for a
 directory with a name that begins with what has been typed, but the use of
 wildcards is also fully supported.

## wcd 6.0.3

=== Makefile ===
# Copyright (C) 2009-2011 Erwin Waterlander
# Copyright (C) 2009 Jari Aalto
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# Visit <http://www.gnu.org/copyleft/gpl.html>


# This makefile is intended only for Unix/Linux.
# See also documentation in directory `doc'.

ifneq (,)
This makefile requires GNU Make.
endif

OBJDIR  = src

all:
	$(MAKE) -C $(OBJDIR)

clean:
	$(MAKE) -C $(OBJDIR) clean

distclean:
	$(MAKE) -C $(OBJDIR) distclean

maintainer-clean:
	$(MAKE) -C $(OBJDIR) maintainer-clean

realclean: maintainer-clean

install:
	$(MAKE) -C $(OBJDIR) install

uninstall:
	$(MAKE) -C $(OBJDIR) uninstall

.PHONY: clean distclean realclean install

# End of file

=== os2/Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 DEFS   += -DWCD_USECURSES
 endif
 
-LIBS_EXTRA = -lcx
+LIBS_EXTRA =
 ifdef ENABLE_NLS
 LIBS_EXTRA += -lintl
 endif
@@ -35,10 +35,10 @@
 ZIPOBJ_EXTRA=bin/wcd.cmd
 
 all :
-	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}
+	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} ENABLE_NLS=${ENABLE_NLS} OS=os/2
 
 install :
-	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS}
+	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS} OS=os/2
 	install -m 755 wcd.cmd $(DESTDIR)${bindir}/wcd.cmd
 
 uninstall :

=== src/Makefile ===
#   Copyright information
#
#       Copyright (C) 2009-2018 Erwin Waterlander
#       Copyright (C) 2009 Jari Aalto
#
#   License
#
#       This program is free software; you can redistribute it and/or
#       modify it under the terms of the GNU General Public License as
#       published by the Free Software Foundation; either version 2 of the
#       License, or (at your option) any later version
#
#       This program is distributed in the hope that it will be useful, but
#       WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#       General Public License for more details at
#       Visit <http://www.gnu.org/copyleft/gpl.html>.
#
#   Description
#
#       This is a GNU Makefile that uses GNU compilers, linkers and cpp. The
#       platform specific issues are determined by the various OS teets that
#       rely on the uname(1) command and directory locations.
#
#   Developer notes
#
#       In order to clean generated POD files and manuals:
#
#           make maintainer-clean
#
#       Set additional flags for the build with variables CFLAGS_USER,
#       DEFS_USER and LDFLAGS_USER.

ifneq (,)
This makefile requires GNU Make.
endif

include version.mk

.PHONY: status uninstall install install-man install-doc install-pdf dist dist-zip dist-tgz
.PHONY: doc man txt html ps pdf mofiles tags merge


.PRECIOUS: %.1 %.pod

CC              ?= gcc
STATIC          =
STRIP           = strip

ENABLE_NLS = 1

PACKAGE         = wcd
EXT             = .exe
PROGRAM         = $(PACKAGE)$(EXT)
BIN             = $(PROGRAM)

PREFIX          = /usr
prefix          = $(PREFIX)
exec_prefix     = $(prefix)
bindir          = $(exec_prefix)/bin
datarootdir     = $(prefix)/share
datadir         = $(datarootdir)

docsubdir       = $(PACKAGE)-$(VERSION)
docdir          = $(datarootdir)/doc/$(docsubdir)
localedir       = $(datarootdir)/locale
sysconfdir      = /etc

# 1 = regular, 5 = conf, 6 = games, 8 = daemons
mandir          = $(datarootdir)/man
man1dir         = $(mandir)/man1


# On some systems (e.g. FreeBSD 4.10) GNU install is installed as `ginstall'.
INSTALL         = install
# On some systems (e.g. GNU Win32) GNU mkdir is installed as `gmkdir'.
MKDIR           = mkdir

INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_SUID    = $(INSTALL) -m 4755

INSTALL_OBJS_BIN   = $(BIN)
HTMLEXT = htm

# English manual
MANFILES_EN  = man/man1/wcd.1
TXTFILES_EN  = man/man1/wcd.txt
HTMLFILES_EN  = man/man1/wcd.$(HTMLEXT)
PSFILES_EN  = man/man1/wcd.ps
PDFFILES_EN  = man/man1/wcd.pdf

# Documents for end users, not for developers:
INSTALL_OBJS_DOC   = \
  ../doc/faq.txt \
  ../doc/whatsnew.txt \
  ../doc/README.txt \
  ../doc/problems.txt \
  ../doc/todo.txt \
  ../doc/INSTALL.txt \
  ../doc/UNIX.txt \
  ../doc/copying.txt

ifdef ENABLE_NLS
POT             = po/$(PACKAGE).pot
POFILES         = $(wildcard po/*.po)
MOFILES         = $(patsubst %.po,%.mo,$(POFILES))
NLSSUFFIX       = -nls
endif

# International manuals
ifdef ENABLE_NLS
MANPOTFILE      = po-man/wcd-man.pot
MANPOFILES      = $(wildcard po-man/*.po)
MANPODFILES     = $(patsubst po-man/%.po,man/%/man1/wcd.pod,$(MANPOFILES))
endif
MANFILES        = $(patsubst %.pod,%.1,$(MANPODFILES))
TXTFILES        = $(patsubst %.pod,%.txt,$(MANPODFILES))
HTMLFILES       = $(patsubst %.pod,%.$(HTMLEXT),$(MANPODFILES))
PSFILES         = $(patsubst %.pod,%.ps,$(MANPODFILES))
PDFFILES        = $(patsubst %.pod,%.pdf,$(MANPODFILES))

CPP             = cpp
CFLAGS_VERSION  = -DVERSION=\"$(VERSION)\" -DVERSION_DATE=\"$(VERSION_DATE)\"
DEF_UNIX        = -DUNIX
EXTRA_DEFS      =

VERSIONSUFFIX   = -bin

# Large File Support (LFS)
LFS             = 1
# DEBUG=1 adds the -g option to CFLAGS, for adding debug symbols.
DEBUG = 0
# DEBUGMSG=1 adds -DDEBUG=1 to CFLAGS, for extra verbose messages.
DEBUGMSG = 0

wcd_os := $(shell uname)

# Enble Unicode
UCS = 1
ifdef WCD_UTF8
        # WCD_UTF8 was used in older versions.
        UCS=1
endif
ifdef UNINORM
        UCS = 1
endif


ZIPOBJ          = bin/$(BIN) \
                  share/man/man1/$(PACKAGE).1 \
                  share/doc/$(docsubdir)/*.* \
                  $(ZIPOBJ_EXTRA)

INSTALL_TARGETS = install-bin install-man install-doc

ifdef ENABLE_NLS
        INSTALL_TARGETS += install-mo
        ZIPOBJ += share/locale/*/LC_MESSAGES/$(PACKAGE).mo
        ZIPOBJ += share/man/*/man1/$(PACKAGE).1
        ZIPOBJ += share/doc/$(docsubdir)/*/*
endif

ifdef ENABLE_NLS
        NLSDEFS    = -DENABLE_NLS -DLOCALEDIR=\"$(localedir)\" -DPACKAGE=\"$(PACKAGE)\"
endif

# ......................................................... OS flags ...

OS =

ifndef OS
ifeq ($(findstring CYGWIN,$(wcd_os)),CYGWIN)
        OS = cygwin
endif
endif

ifndef OS
ifeq ($(findstring MSYS,$(wcd_os)),MSYS)
        OS = msys
# MSYS 1 does not support locales and no Unicode.
ifeq ($(shell ./chk_loc.sh en_US.utf8),no)
        MSYS_VERSION=1
else
        MSYS_VERSION=2
endif
endif
endif

ifndef OS
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
        OS = mingw
endif
endif

ifndef OS
ifneq ($(DJGPP),)
        OS = msdos
endif
endif

ifndef OS
ifneq (, $(wildcard /opt/csw))
        OS = sun
endif
endif

ifndef OS
        OS=$(shell echo $(wcd_os) | tr '[A-Z]' '[a-z]')
endif


ifeq (cygwin,$(OS))
ifdef ENABLE_NLS
        LIBS_EXTRA    = -lintl -liconv -lmpr
else
        LIBS_EXTRA    = -lmpr
endif
        UNINORM = 1  
        LDFLAGS_EXTRA = -Wl,--enable-auto-import
        INSTALL_TARGETS += install-profile
        docsubdir       = $(PACKAGE)
        MACHINE := $(subst -pc-cygwin,,$(shell gcc -dumpmachine))
        VERSIONSUFFIX   = -cygwin-$(MACHINE)
endif

ifeq (os/2,$(OS))
        prefix = c:/usr
        PROGRAM = wcdos2.exe
        DEF_UNIX =
        UCS =
        UNINORM =
        LDFLAGS_EXTRA = -Zhigh-mem -Zomf -Zargs-resp
        ZIPOBJ_EXTRA=bin/wcd.cmd
        VERSIONSUFFIX = -os2
        LIBS_EXTRA =
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl
endif
endif

ifeq (mingw,$(OS))
        CC = gcc
        DEF_UNIX =
        LIBS_EXTRA = -lkernel32 -luser32 -lmpr
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (msdos,$(OS))
        CC = gcc
        DEF_UNIX =
        UCS =
        UNINORM =
endif

ifeq (msys,$(OS))
        CC = gcc
        CFLAGS_OS = -DWCD_MSYS
        PROGRAM = wcdmsys.exe
        LIBS_EXTRA  = -lkernel32 -luser32 -lmpr
        MACHINE := $(subst -pc-msys,,$(shell gcc -dumpmachine))
ifeq ($(MSYS_VERSION),1)
        UCS =
        UNINORM =
        VERSIONSUFFIX = -msys1-$(MACHINE)-$(CURSES)
else
        UCS = 1
        UNINORM = 1
        VERSIONSUFFIX = -msys2-$(MACHINE)
endif
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (freebsd,$(OS))
        # Running under FreeBSD
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif

ifeq (darwin, $(OS))
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif


ifeq (sun,$(OS))
        # Running under SunOS/Solaris
        LIBS_EXTRA = -lintl
endif

ifeq (hp-ux,$(OS))
        # Running under HP-UX
        EXTRA_DEFS += -Dhpux -D_HPUX_SOURCE -D_XOPEN_SOURCE_EXTENDED

        # These flags were for native HP compiler
        # CFLAGS_OS = -O -Aa
endif

# .......................................................... unicode ...

ifdef UCS
        CFLAGS_UCS = -std=gnu99
        WDEFS      = -DWCD_UNICODE
endif
ifdef UNINORM
        CFLAGS_UCS = -std=gnu99
        WDEFS      = -DWCD_UNICODE -DWCD_UNINORM
        LIB_UNISTRING  = -lunistring
endif

ifdef UCS
UCSSUFFIX = -ucs
EXTRA_OBJ += matchw.o
endif

# ........................................................... curses ...

# possible values: ncurses, curses, pdcurses, pdcursesw or <empty>

ifdef UCS
        CURSES = ncursesw
else
        CURSES = ncurses
endif


# The default console for msys1 is the cmd.exe console.  rxvt and mintty are
# available for msys1, but I guess most people use cmd, console, or conemu for
# msys1.  Therefore we use pdcurses for msys1.  msys2's default console is
# mintty. For msys2 we use ncurses.
ifeq (msys,$(OS))
ifeq ($(MSYS_VERSION),1)
        CURSES = pdcurses
endif
endif

# The native Windows versions use PDCurses, because there are problems
# with the ncurses mingw port.
# All native Windows versions (with and without Unicode support) use wide
# (Unicode) curses functions.
ifeq (mingw,$(OS))
        CURSES = pdcursesw
endif

ifdef CURSES
ifdef UCS
EXTRA_OBJ += wcwidth.o
endif
endif

ifneq (,$(CURSES))
        DEFS_CURSES = -DWCD_USECURSES
        LIB_CURSES  = -l$(CURSES)
ifeq (os/2,$(OS))
        LIB_CURSES  += -ltinfo
endif
endif


INCPREFIX=/usr
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
ifeq ($(shell gcc -dumpmachine),i686-w64-mingw32)
INCPREFIX=/mingw32
CFLAGS_COMPILER = -DWCD_MINGW32_W64=1
else
ifeq ($(shell gcc -dumpmachine),x86_64-w64-mingw32)
INCPREFIX=/mingw64
else
INCPREFIX=/mingw
endif
endif
endif

# Each ncurses variant has its own include directory
# ncurses (normal)/ncursesw (wide char)/ncursest (threads)
ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(wildcard $(INCPREFIX)/include/$(CURSES)/curses.h),)
        INCFLAGS = -I$(INCPREFIX)/include/$(CURSES) -I$(INCPREFIX)/include
endif
ifeq ($(NCURSES_DEBUG), 1)
        LIB_CURSES  = -l$(CURSES)_g
endif
else
        INCFLAGS = -I$(INCPREFIX)/include
endif

ifeq ($(CURSES),ncursesw)
        EXTRA_DEFS += -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED
endif

ifeq ($(CURSES),pdcursesw)
        EXTRA_DEFS += -DPDC_STATIC_BUILD -DPDC_WIDE
endif

# Local installation prefix of ncurses.
#LOCAL_NCURSES  = $(HOME)
#
#ifneq (, $(wildcard $(LOCAL_NCURSES)/include/ncurses.h))
#       NCFLAG = -I$(LOCAL_NCURSES)/include
#       NLFLAG = -L$(LOCAL_NCURSES)/lib
#endif

# ............................................................ flags ...

# Statically linking of a specific library can be done by linking
# to a lib*.a library file instead a lib*.s* library file.
# To link ncurses statically (if your system links by default
# dynamically) comment the LDFLAGS line and add the 'libncurses.a' file
# (often found as /usr/lib/libncurses.a) to the OBJS1 list.

CFLAGS_USER     =
ifeq ($(DEBUG), 1)
CFLAGS_OPT = -O0
else
CFLAGS_OPT = -O2
endif

CFLAGS  ?=
CFLAGS  += $(CFLAGS_OPT)
ifeq ($(DEBUG), 1)
        CFLAGS += -g
endif
CFLAGS  += -Wall -Wextra -Wno-unused-parameter -Wconversion $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)


EXTRA_CFLAGS    = -Ic3po \
                  $(CFLAGS_VERSION) \
                  $(CFLAGS_OS) \
                  $(CFLAGS_UCS) \
                  $(CFLAGS_COMPILER) \
                  $(WDEFS) \
                  $(NLSDEFS) \
                  $(NCFLAG) \
                  $(INCFLAGS) \
                  -DDEBUG=$(DEBUGMSG)

ifdef LFS
        EXTRA_CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
endif

ifdef ASCII_TREE
        EXTRA_CFLAGS += -DASCII_TREE
endif

ifdef STATIC
        LDFLAG_STATIC = -static
endif

LDFLAGS_USER   =
LDFLAGS ?=
LDFLAGS += $(RPM_LD_FLAGS) \
           $(LDFLAGS_EXTRA) \
           $(NLFLAG) \
           $(LDFLAG_STATIC) \
           $(LDFLAGS_USER)

LIBS = $(LIB_CURSES) \
       $(LIB_UNISTRING) \
       $(LIBS_EXTRA)

DEFS_USER   =
DEFS            = $(DEF_UNIX) $(DEFS_CURSES) $(EXTRA_DEFS) $(DEFS_USER)

# .......................................................... targets ...

OBJS1 = \
        wcd.o \
        match.o \
        stack.o \
        nameset.o \
        intset.o \
        Error.o \
        Text.o \
        WcdStack.o \
        dirnode.o \
        display.o \
        wfixpath.o \
        wcddir.o \
        matchl.o \
        querycp.o \
        finddirs.o \
        $(EXTRA_OBJ)

ifneq (,$(CURSES))
OBJS1 += colors.o \
        graphics.o
endif

all: $(BIN) doc mofiles man

status:
	@echo "-- $(PACKAGE) Makefile settings begin --"
	@echo "OS            = $(OS)"

=== win64psh/Makefile ===

PREFIX = c:/usr/local64
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LIBS_EXTRA = -lkernel32 -luser32 -lmpr

#CC = x86_64-w64-mingw32-gcc
#STRIP = x86_64-w64-mingw32-strip
CC = gcc
STRIP = strip
CFLAGS = -O2 -Wall -Wextra -Wconversion -Wno-unused-parameter
CURSES = pdcursesw
ENABLE_NLS =
DEFS   = -DWCD_WINPWRSH

ifdef CURSES
LIB_CURSES = -l${CURSES}
DEFS   += -DWCD_USECURSES -DPDC_STATIC_BUILD
DEFS   += -DPDC_WIDE
EXTRA_OBJ += wcwidth.o
endif


ifdef ENABLE_NLS
LIBS_EXTRA += -lintl -liconv
endif

UCS=1

ifdef UNINORM
UCS=1
endif

ifdef UCS
EXTRA_OBJ += matchw.o
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdwin64psh.exe
VERSIONSUFFIX = -win64psh
ZIPOBJ_EXTRA =
# Using MinGW gettext,iconv
ifdef ENABLE_NLS
ZIPOBJ_EXTRA += bin/libintl-8.dll bin/libiconv-2.dll
endif

ifdef UNINORM
ifndef ENABLE_NLS
# libunistring needs libiconv
ZIPOBJ_EXTRA += bin/libiconv-2.dll
endif
ZIPOBJ_EXTRA += bin/libunistring-2.dll
endif

ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(findstring libwinpthread,$(ZIPOBJ_EXTRA)),libwinpthread)
ZIPOBJ_EXTRA += bin/libwinpthread-1.dll
endif
endif


all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} EXTRA_OBJ="${EXTRA_OBJ}" ENABLE_NLS=${ENABLE_NLS} CC=$(CC)

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} EXTRA_OBJ="${EXTRA_OBJ}" INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS} CC=$(CC)

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM} STRIP=$(STRIP)

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== debian/changelog ===
wcd (6.0.3-2) unstable; urgency=medium

  * QA upload.
  * Fix ftcbfs. (Closes: #929759)
  * Update Vcs to debian/wcd repo.
  * Add Rules-Requires-Root for lintian warning.
  * Use https with homepage.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 02 Jan 2020 23:55:04 +0000

wcd (6.0.3-1) unstable; urgency=medium

  * QA upload.
  * Update to upstream 6.0.3.
  * Update Standards-Version to 4.4.1.
  * Update compate level to 12.
  * Mark maintainer to QA.
  * Remove the patch, this version is not using build date.
  * Combine both NEWS file to a single NEWS.
  * Push to salsa and update Vcs.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 24 Dec 2019 23:08:07 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: wcd
 Section: utils
 Priority: optional
-Maintainer: Jari Aalto <jari.aalto@cante.net>
-Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 10), libncursesw5-dev, libunistring-dev, ghostscript
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/wcd.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/wcd.git
-Homepage: http://waterlan.home.xs4all.nl
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends: dpkg-dev (>= 1.16.2), debhelper-compat (= 12), libncursesw5-dev, libunistring-dev, ghostscript
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/wcd
+Vcs-Git: https://salsa.debian.org/debian/wcd.git
+Homepage: https://waterlan.home.xs4all.nl
 
 Package: wcd
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE = wcd
EXE	= .exec

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

#  UCS; Activate unicode UTF-8 support
#  NLS; Enable international support
#  DOTWCD; Use ~/.wcd/ configuration directory
#  UNINORM; Enable Unicode normalization

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

MAKE_OPTIONS = \
 EXT=$(EXE) \
 UCS=1 \
 NLS=1 \
 DOTWCD=1 \
 UNINORM=1 \
 CPP_FLAGS_POD=-Dunix \
 LDFLAGS_USER="$(LDFLAGS)" \
 CFLAGS_USER="$(CPPFLAGS) $(CFLAGS)"

include debian/debian-vars.mk

override_dh_auto_build:
	dh_auto_build --sourcedirectory=src -- $(MAKE_OPTIONS) all

override_dh_auto_clean:
	$(MAKE) -C src $(MAKE_OPTIONS) clean

override_dh_auto_install:
	$(MAKE) -C src \
		DESTDIR=$(PKGDIR) \
		prefix=/usr \
		BINDIR=$(LIBDIR) \
		DOCDIR=$(PKGDOCDIR) \
		MANDIR1=$(MAN7DIR) \
		INSTALL_OBJS_DOC_INSTALL= \
		INSTALL_OBJS_DOC_COPYING= \
		$(MAKE_OPTIONS) \
		install install-profile

	# Remove /usr/share/doc/wcd-VERSION
	# Not used in Debian

	rm -rf $(PKGDOCDIR)-*/

	# Relocate scripts

	install -d -m 755 $(SHAREDIR)

	install -m 644 \
		$(PKGDIR)/etc/profile.d/wcd.csh \
		$(SHAREDIR)/wcd-include.csh

	install -m 644 \
		debian/wcd-include.sh \
		$(SHAREDIR)/wcd-include.sh

	rm -rf  debian/$(PACKAGE)/etc

man:
	# target: man
	install -d -m 755 $(MAN1DIR)

	# Create manual page redirection file
	man=$(MAN1DIR)/$(PACKAGE)$(EXE).1 ; \
	echo ".so man1/wcd.1.gz" > $$man ; \
	gzip --best $$man

override_dh_installchangelogs:
	dh_installchangelogs doc/whatsnew.txt

override_dh_installman: man
	dh_installman
	rm -f $(PKGDOCDIR)/wcd.txt*

%:
	dh $@

.PHONY: man

# End of file

=== debian/watch ===
version=3
# http://sf.net/wcd/wcd-([.\d]*)\.tar\.gz
https://waterlan.home.xs4all.nl .*wcd-(\d\.[.\d]+)\.tar\.gz
